---------------------------------------------------------------------------------------
-- Title          : Wishbone slave core for Converter board registers
---------------------------------------------------------------------------------------
-- File           : conv_regs.vhd
-- Author         : auto-generated by wbgen2 from conv_regs.wb
-- Created        : Thu Feb 13 17:08:07 2014
-- Standard       : VHDL'87
---------------------------------------------------------------------------------------
-- THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE conv_regs.wb
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
---------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.wbgen2_pkg.all;

entity conv_regs is
  port (
    rst_n_i                                  : in     std_logic;
    clk_sys_i                                : in     std_logic;
    wb_adr_i                                 : in     std_logic_vector(3 downto 0);
    wb_dat_i                                 : in     std_logic_vector(31 downto 0);
    wb_dat_o                                 : out    std_logic_vector(31 downto 0);
    wb_cyc_i                                 : in     std_logic;
    wb_sel_i                                 : in     std_logic_vector(3 downto 0);
    wb_stb_i                                 : in     std_logic;
    wb_we_i                                  : in     std_logic;
    wb_ack_o                                 : out    std_logic;
    wb_stall_o                               : out    std_logic;
    clk_wr_i                                 : in     std_logic;
-- Port for std_logic_vector field: 'ID register bits' in reg: 'BIDR'
    reg_id_bits_i                            : in     std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'Gateware version' in reg: 'SR'
    reg_sr_gwvers_i                          : in     std_logic_vector(7 downto 0);
-- Port for std_logic_vector field: 'Status of on-board switches' in reg: 'SR'
    reg_sr_switches_i                        : in     std_logic_vector(7 downto 0);
-- Port for std_logic_vector field: 'RTM detection lines~\cite{rtm-det}' in reg: 'SR'
    reg_sr_rtm_i                             : in     std_logic_vector(5 downto 0);
-- Ports for BIT field: 'Communication watchdog timer status' in reg: 'SR'
    reg_sr_i2c_wdto_o                        : out    std_logic;
    reg_sr_i2c_wdto_i                        : in     std_logic;
    reg_sr_i2c_wdto_load_o                   : out    std_logic;
-- Port for BIT field: 'White Rabbit present' in reg: 'SR'
    reg_sr_wrpres_i                          : in     std_logic;
-- Ports for BIT field: 'Reset unlock bit' in reg: 'CR'
    reg_cr_rst_unlock_o                      : out    std_logic;
    reg_cr_rst_unlock_i                      : in     std_logic;
    reg_cr_rst_unlock_load_o                 : out    std_logic;
-- Ports for BIT field: 'Reset bit' in reg: 'CR'
    reg_cr_rst_o                             : out    std_logic;
    reg_cr_rst_i                             : in     std_logic;
    reg_cr_rst_load_o                        : out    std_logic;
-- Ports for PASS_THROUGH field: 'Manual Pulse Trigger' in reg: 'CR'
    reg_cr_mpt_o                             : out    std_logic_vector(7 downto 0);
    reg_cr_mpt_wr_o                          : out    std_logic;
-- Port for std_logic_vector field: 'Pulse counter value' in reg: 'CH1PCR'
    reg_ch1pcr_o                             : out    std_logic_vector(31 downto 0);
    reg_ch1pcr_i                             : in     std_logic_vector(31 downto 0);
    reg_ch1pcr_load_o                        : out    std_logic;
-- Port for std_logic_vector field: 'Pulse counter value' in reg: 'CH2PCR'
    reg_ch2pcr_o                             : out    std_logic_vector(31 downto 0);
    reg_ch2pcr_i                             : in     std_logic_vector(31 downto 0);
    reg_ch2pcr_load_o                        : out    std_logic;
-- Port for std_logic_vector field: 'Pulse counter value' in reg: 'CH3PCR'
    reg_ch3pcr_o                             : out    std_logic_vector(31 downto 0);
    reg_ch3pcr_i                             : in     std_logic_vector(31 downto 0);
    reg_ch3pcr_load_o                        : out    std_logic;
-- Port for std_logic_vector field: 'Pulse counter value' in reg: 'CH4PCR'
    reg_ch4pcr_o                             : out    std_logic_vector(31 downto 0);
    reg_ch4pcr_i                             : in     std_logic_vector(31 downto 0);
    reg_ch4pcr_load_o                        : out    std_logic;
-- Port for std_logic_vector field: 'Pulse counter value' in reg: 'CH5PCR'
    reg_ch5pcr_o                             : out    std_logic_vector(31 downto 0);
    reg_ch5pcr_i                             : in     std_logic_vector(31 downto 0);
    reg_ch5pcr_load_o                        : out    std_logic;
-- Port for std_logic_vector field: 'Pulse counter value' in reg: 'CH6PCR'
    reg_ch6pcr_o                             : out    std_logic_vector(31 downto 0);
    reg_ch6pcr_i                             : in     std_logic_vector(31 downto 0);
    reg_ch6pcr_load_o                        : out    std_logic;
-- Port for std_logic_vector field: 'TAI seconds counter bits 31..0' in reg: 'TVLR'
    reg_tvlr_o                               : out    std_logic_vector(31 downto 0);
    reg_tvlr_i                               : in     std_logic_vector(31 downto 0);
    reg_tvlr_load_o                          : out    std_logic;
-- Port for std_logic_vector field: 'TAI seconds counter bits 39..32' in reg: 'TVHR'
    reg_tvhr_o                               : out    std_logic_vector(7 downto 0);
    reg_tvhr_i                               : in     std_logic_vector(7 downto 0);
    reg_tvhr_load_o                          : out    std_logic;
-- FIFO write request
    reg_tf_wr_req_i                          : in     std_logic;
-- FIFO full flag
    reg_tf_wr_full_o                         : out    std_logic;
-- FIFO empty flag
    reg_tf_wr_empty_o                        : out    std_logic;
    reg_tf_chan_i                            : in     std_logic_vector(5 downto 0);
    reg_tf_wrtag_i                           : in     std_logic;
    reg_tf_cyc_i                             : in     std_logic_vector(27 downto 0);
    reg_tf_tai_l_i                           : in     std_logic_vector(31 downto 0);
    reg_tf_tai_h_i                           : in     std_logic_vector(7 downto 0)
  );
end conv_regs;

architecture syn of conv_regs is

signal reg_tf_rst_n                             : std_logic      ;
signal reg_tf_in_int                            : std_logic_vector(74 downto 0);
signal reg_tf_out_int                           : std_logic_vector(74 downto 0);
signal reg_tf_rdreq_int                         : std_logic      ;
signal reg_tf_rdreq_int_d0                      : std_logic      ;
signal reg_tf_full_int                          : std_logic      ;
signal reg_tf_empty_int                         : std_logic      ;
signal reg_tf_clear_bus_int                     : std_logic      ;
signal reg_tf_usedw_int                         : std_logic_vector(6 downto 0);
signal ack_sreg                                 : std_logic_vector(9 downto 0);
signal rddata_reg                               : std_logic_vector(31 downto 0);
signal wrdata_reg                               : std_logic_vector(31 downto 0);
signal bwsel_reg                                : std_logic_vector(3 downto 0);
signal rwaddr_reg                               : std_logic_vector(3 downto 0);
signal ack_in_progress                          : std_logic      ;
signal wr_int                                   : std_logic      ;
signal rd_int                                   : std_logic      ;
signal allones                                  : std_logic_vector(31 downto 0);
signal allzeros                                 : std_logic_vector(31 downto 0);

begin
-- Some internal signals assignments. For (foreseen) compatibility with other bus standards.
  wrdata_reg <= wb_dat_i;
  bwsel_reg <= wb_sel_i;
  rd_int <= wb_cyc_i and (wb_stb_i and (not wb_we_i));
  wr_int <= wb_cyc_i and (wb_stb_i and wb_we_i);
  allones <= (others => '1');
  allzeros <= (others => '0');
-- 
-- Main register bank access process.
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      ack_sreg <= "0000000000";
      ack_in_progress <= '0';
      rddata_reg <= "00000000000000000000000000000000";
      reg_sr_i2c_wdto_load_o <= '0';
      reg_cr_rst_unlock_load_o <= '0';
      reg_cr_rst_load_o <= '0';
      reg_cr_mpt_wr_o <= '0';
      reg_ch1pcr_load_o <= '0';
      reg_ch2pcr_load_o <= '0';
      reg_ch3pcr_load_o <= '0';
      reg_ch4pcr_load_o <= '0';
      reg_ch5pcr_load_o <= '0';
      reg_ch6pcr_load_o <= '0';
      reg_tvlr_load_o <= '0';
      reg_tvhr_load_o <= '0';
      reg_tf_clear_bus_int <= '0';
      reg_tf_rdreq_int <= '0';
    elsif rising_edge(clk_sys_i) then
-- advance the ACK generator shift register
      ack_sreg(8 downto 0) <= ack_sreg(9 downto 1);
      ack_sreg(9) <= '0';
      if (ack_in_progress = '1') then
        if (ack_sreg(0) = '1') then
          reg_sr_i2c_wdto_load_o <= '0';
          reg_cr_rst_unlock_load_o <= '0';
          reg_cr_rst_load_o <= '0';
          reg_cr_mpt_wr_o <= '0';
          reg_ch1pcr_load_o <= '0';
          reg_ch2pcr_load_o <= '0';
          reg_ch3pcr_load_o <= '0';
          reg_ch4pcr_load_o <= '0';
          reg_ch5pcr_load_o <= '0';
          reg_ch6pcr_load_o <= '0';
          reg_tvlr_load_o <= '0';
          reg_tvhr_load_o <= '0';
          reg_tf_clear_bus_int <= '0';
          ack_in_progress <= '0';
        else
          reg_sr_i2c_wdto_load_o <= '0';
          reg_cr_rst_unlock_load_o <= '0';
          reg_cr_rst_load_o <= '0';
          reg_cr_mpt_wr_o <= '0';
          reg_ch1pcr_load_o <= '0';
          reg_ch2pcr_load_o <= '0';
          reg_ch3pcr_load_o <= '0';
          reg_ch4pcr_load_o <= '0';
          reg_ch5pcr_load_o <= '0';
          reg_ch6pcr_load_o <= '0';
          reg_tvlr_load_o <= '0';
          reg_tvhr_load_o <= '0';
        end if;
      else
        if ((wb_cyc_i = '1') and (wb_stb_i = '1')) then
          case rwaddr_reg(3 downto 0) is
          when "0000" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= reg_id_bits_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "0001" => 
            if (wb_we_i = '1') then
              reg_sr_i2c_wdto_load_o <= '1';
            end if;
            rddata_reg(7 downto 0) <= reg_sr_gwvers_i;
            rddata_reg(15 downto 8) <= reg_sr_switches_i;
            rddata_reg(21 downto 16) <= reg_sr_rtm_i;
            rddata_reg(22) <= reg_sr_i2c_wdto_i;
            rddata_reg(23) <= reg_sr_wrpres_i;
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "0010" => 
            if (wb_we_i = '1') then
              reg_cr_rst_unlock_load_o <= '1';
              reg_cr_rst_load_o <= '1';
              reg_cr_mpt_wr_o <= '1';
            end if;
            rddata_reg(0) <= reg_cr_rst_unlock_i;
            rddata_reg(1) <= reg_cr_rst_i;
            rddata_reg(2) <= 'X';
            rddata_reg(3) <= 'X';
            rddata_reg(4) <= 'X';
            rddata_reg(5) <= 'X';
            rddata_reg(6) <= 'X';
            rddata_reg(7) <= 'X';
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "0011" => 
            if (wb_we_i = '1') then
              reg_ch1pcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_ch1pcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "0100" => 
            if (wb_we_i = '1') then
              reg_ch2pcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_ch2pcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "0101" => 
            if (wb_we_i = '1') then
              reg_ch3pcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_ch3pcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "0110" => 
            if (wb_we_i = '1') then
              reg_ch4pcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_ch4pcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "0111" => 
            if (wb_we_i = '1') then
              reg_ch5pcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_ch5pcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "1000" => 
            if (wb_we_i = '1') then
              reg_ch6pcr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_ch6pcr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "1001" => 
            if (wb_we_i = '1') then
              reg_tvlr_load_o <= '1';
            end if;
            rddata_reg(31 downto 0) <= reg_tvlr_i;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "1010" => 
            if (wb_we_i = '1') then
              reg_tvhr_load_o <= '1';
            end if;
            rddata_reg(7 downto 0) <= reg_tvhr_i;
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "1011" => 
            if (wb_we_i = '1') then
            end if;
            if (reg_tf_rdreq_int_d0 = '0') then
              reg_tf_rdreq_int <= not reg_tf_rdreq_int;
            else
              rddata_reg(5 downto 0) <= reg_tf_out_int(5 downto 0);
              rddata_reg(31) <= reg_tf_out_int(6);
              ack_in_progress <= '1';
              ack_sreg(0) <= '1';
            end if;
            rddata_reg(6) <= 'X';
            rddata_reg(7) <= 'X';
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
          when "1100" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(27 downto 0) <= reg_tf_out_int(34 downto 7);
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "1101" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(31 downto 0) <= reg_tf_out_int(66 downto 35);
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "1110" => 
            if (wb_we_i = '1') then
            end if;
            rddata_reg(7 downto 0) <= reg_tf_out_int(74 downto 67);
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "1111" => 
            if (wb_we_i = '1') then
              if (wrdata_reg(18) = '1') then
                reg_tf_clear_bus_int <= '1';
              end if;
            end if;
            rddata_reg(16) <= reg_tf_full_int;
            rddata_reg(17) <= reg_tf_empty_int;
            rddata_reg(18) <= '0';
            rddata_reg(6 downto 0) <= reg_tf_usedw_int;
            rddata_reg(7) <= 'X';
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when others =>
-- prevent the slave from hanging the bus on invalid address
            ack_in_progress <= '1';
            ack_sreg(0) <= '1';
          end case;
        end if;
      end if;
    end if;
  end process;
  
  
-- Drive the data output bus
  wb_dat_o <= rddata_reg;
-- ID register bits
-- Gateware version
-- Status of on-board switches
-- RTM detection lines~\cite{rtm-det}
-- Communication watchdog timer status
  reg_sr_i2c_wdto_o <= wrdata_reg(22);
-- White Rabbit present
-- Reset unlock bit
  reg_cr_rst_unlock_o <= wrdata_reg(0);
-- Reset bit
  reg_cr_rst_o <= wrdata_reg(1);
-- Manual Pulse Trigger
-- pass-through field: Manual Pulse Trigger in register: CR
  reg_cr_mpt_o <= wrdata_reg(9 downto 2);
-- Pulse counter value
  reg_ch1pcr_o <= wrdata_reg(31 downto 0);
-- Pulse counter value
  reg_ch2pcr_o <= wrdata_reg(31 downto 0);
-- Pulse counter value
  reg_ch3pcr_o <= wrdata_reg(31 downto 0);
-- Pulse counter value
  reg_ch4pcr_o <= wrdata_reg(31 downto 0);
-- Pulse counter value
  reg_ch5pcr_o <= wrdata_reg(31 downto 0);
-- Pulse counter value
  reg_ch6pcr_o <= wrdata_reg(31 downto 0);
-- TAI seconds counter bits 31..0
  reg_tvlr_o <= wrdata_reg(31 downto 0);
-- TAI seconds counter bits 39..32
  reg_tvhr_o <= wrdata_reg(7 downto 0);
-- extra code for reg/fifo/mem: Tag FIFO
  reg_tf_in_int(5 downto 0) <= reg_tf_chan_i;
  reg_tf_in_int(6) <= reg_tf_wrtag_i;
  reg_tf_in_int(34 downto 7) <= reg_tf_cyc_i;
  reg_tf_in_int(66 downto 35) <= reg_tf_tai_l_i;
  reg_tf_in_int(74 downto 67) <= reg_tf_tai_h_i;
  reg_tf_rst_n <= rst_n_i and (not reg_tf_clear_bus_int);
  reg_tf_INST : wbgen2_fifo_async
    generic map (
      g_size               => 128,
      g_width              => 75,
      g_usedw_size         => 7
    )
    port map (
      wr_req_i             => reg_tf_wr_req_i,
      wr_full_o            => reg_tf_wr_full_o,
      wr_empty_o           => reg_tf_wr_empty_o,
      rd_full_o            => reg_tf_full_int,
      rd_empty_o           => reg_tf_empty_int,
      rd_usedw_o           => reg_tf_usedw_int,
      rd_req_i             => reg_tf_rdreq_int,
      rst_n_i              => reg_tf_rst_n,
      wr_clk_i             => clk_wr_i,
      rd_clk_i             => clk_sys_i,
      wr_data_i            => reg_tf_in_int,
      rd_data_o            => reg_tf_out_int
    );
  
-- extra code for reg/fifo/mem: FIFO 'Tag FIFO' data output register 0
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      reg_tf_rdreq_int_d0 <= '0';
    elsif rising_edge(clk_sys_i) then
      reg_tf_rdreq_int_d0 <= reg_tf_rdreq_int;
    end if;
  end process;
  
  
-- extra code for reg/fifo/mem: FIFO 'Tag FIFO' data output register 1
-- extra code for reg/fifo/mem: FIFO 'Tag FIFO' data output register 2
-- extra code for reg/fifo/mem: FIFO 'Tag FIFO' data output register 3
  rwaddr_reg <= wb_adr_i;
  wb_stall_o <= (not ack_sreg(0)) and (wb_stb_i and wb_cyc_i);
-- ACK signal generation. Just pass the LSB of ACK counter.
  wb_ack_o <= ack_sreg(0);
end syn;
